<?php

class XmlRpcDataSource 
{
  var $client;
  var $fetchSpecification;

  var $fetchObjectAction;
  var $insertObjectAction;
  var $updateObjectAction;
  var $deleteObjectAction;
                            
  function XmlRpcDataSource($server,
                            $fetchObject,
                            $insertObject,
                            $updateObject,
                            $deleteObject)
  {
    $this->client = $server;
    $this->fetchObjectAction = $fetchObject;
    $this->insertObjectAction = $insertObject;
    $this->updateObjectAction = $updateObject;
    $this->deleteObjectAction = $deleteObject;
  }

  function setFetchSpecification($_text, $_qualifiers,$_hints, $connect = "OR")
  {
    for ($count=0; $count < count($_hints); $count++)
      $hints[$count]  = new xmlrpcval($_hints[$count]);

    $_qualifier = "";

    for ($icount=0; $icount < count($_qualifiers); $icount++)
    {
       if ($icount != 0) $and = " " . $connect . " ";
       else $and = "";
       $_qualifier = $_qualifier . $and .$_qualifiers[$icount] . " like '*" . $_text . "*'";
    }

    $this->fetchSpecification = new xmlrpcval( array(
	    "qualifier" => new xmlrpcval($_qualifier,"string"),
      "hints"     => new xmlrpcval( array( 
        "attributes" => new xmlrpcval( 
          $hints
        ,"array")) 
      ,"struct")) 
    ,"struct");

  }

  function fetchObjects()
  {
    return $this->invokeMethod($this->fetchObjectAction,$this->fetchSpecification);  
  } 

  function insertObject($_obj)
  {
    return $this->invokeMethod($this->updateObjectAction,
        $_obj);  
  } 

  function invokeMethod($method,$params)
  {
    // create a new xmlrpc message and send it
    $message = new xmlrpcmsg($method,array($params));

    // print htmlentities($message->serialize());
    return $this->client->sendMessage($message);
  }
}
